#include "common.h"

class BasicStrategy: public SchedulingStrategy{
 public:

    BasicStrategy(int nproc);

    int is_available(Job *j, Job *waitq, Job *runq);
    void allocate_processors(Job *waitq, Job *runq);
    
 private:
    int get_optimal_allocation(Job *j, Job *runq);
    void opt_allocate(Job *j, Job *runq, int nalloc);
    void expand_running_jobs(Job *runq);
};
